<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading },
  name: 'CheckoutForm',
  props: {
    title: String,
    data: Object
  },
  data(){
    return{
        dataProduct: this.data,
        reDataProducts: [],
        formTitle: this.title ? this.title : 'Checkout Product',
        viewStatus: this.title == 'View Detail Order'
    }
  },
  setup() {
    const success = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
            weight: 0,
            amount: 0,
            paymentType: 'CASH'
         });
    const rules = computed(() => {
         return {
            weight: { required },
            amount: {required},
            paymentType: (required)
         }
    });
    const v$ = useValidate(rules, state)
    async function saveData(dataProduct) {
      loading.value = true;
      let orderDetailDto = []
      for(let d of dataProduct){
          orderDetailDto.push({
              productId: d.id,
              quantity: d.quantity,
              price: d.price
          })
      }
      const requestData = {
        orderDetailDto: orderDetailDto,
        weight: state.weight,
        amount: state.amount,
        userId: store.state.userId,
        orderStatus: "NEW",
        shipmentStatus: "NEW",
        paymentType: state.paymentType
      }
      const result = await HTTP.post(`orders`, JSON.stringify( requestData )).then(response => {
            success.value = response.data.message
            store.state.keranjang = [];
            localStorage.keranjang = '';
            setTimeout(() => {
                this.$emit('close-modal')
            },1000)
        })
        .catch(e => {
            const jsonError = e.toJSON();
            error.value = jsonError.message

        })
      loading.value = false;
    }

    return {
      success,
      loading,
      error,
      state,
      v$,
      saveData
    };
  },methods: {
    onSubmit(e) {
      this.v$.$validate()
      if(!this.v$.$error){
         this.saveData(this.reDataProduct)
      }
      e.preventDefault()
    },
    onReset() {
        e.preventDefault()
    },
    totalingAmount(){
        let allAmount = this.reDataProduct
        this.state.amount = allAmount.reduce((a, b) => a + ((b['price'] * b['quantity']) || 0), 0)
        this.state.weight = allAmount.reduce((a, b) => a + ((b['weight'] * b['quantity']) || 0), 0)
    },
    getProductName(id){
        return HTTP.get(`products/`+id).then(response => {
            return response.data.data.name
        })
        .catch(e => {
            return e
        })
    }
  },mounted(){
    this.totalingAmount();
    this.state.weight = this.viewStatus ? this.data.weight || 0 : this.state.weight;
    for(let reidp=0; reidp < this.reDataProduct.length; reidp++){
        HTTP.get(`products/`+this.reDataProduct[reidp].productId).then(response => {
            this.reDataProduct[reidp].name = response.data.data.name
        })
        .catch(e => {
            this.reDataProduct[reidp].name = e
        })
    }
  },computed: {
    reDataProduct(){
      const objEntries = this.viewStatus ? Object.entries(this.data.orderDetailDto): Object.entries(this.data);
      const merged = objEntries.map(item => {
        return { quantity : item[1].quantity, ...item[1]}
      })
      return merged;
    }      
  }
}
</script>
<template>
    <Loading v-if="loading"/>
    <b-form v-if="!loading" @submit="onSubmit" @reset="onReset">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <div class="header-title">
                    <h4 class="card-title">
                        {{ formTitle }}
                    </h4>
                </div>
                <a class="badge bg-warning mr-2" href="#" @click="$emit('close-modal')" ><i class="ri-arrow-go-back-fill mr-0"></i></a>
            </div>
            <div class="col-md-12" v-if="error || success">
                <div class="alert alert-danger" v-if="error">
                    <div class="iq-alert-text">
                    {{error}}
                    </div>
                </div>                    
                <div class="alert alert-success" v-if="success">
                    <div class="iq-alert-text">
                    {{success}}
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">            
                    <div class="accordion" role="tablist">
                        <b-card no-body class="mb-1" v-for="(item, index) in reDataProduct" >
                            <b-card-header header-tag="header" class="p-1" role="tab">
                                <h5 class="card-title-accordion" v-b-toggle="'accordion-'+index" >{{ item.name }}</h5>
                            </b-card-header>
                            <b-collapse :id="'accordion-'+index" visible accordion="my-accordion" role="tabpanel">
                                <b-card-body>
                                    <b-card-text>
                                        <div class="d-flex align-items-left">
                                            <img src="../../assets/images/table/product/01.jpg" class="img-fluid rounded avatar-50 mr-3" alt="image">
                                            <div>
                                                <p class="mb-0"><small>
                                                    <b-input-group prepend="Quantity">
                                                        <template #append>
                                                            <b-input-group-text class="b-input-group-text-custome">/{{item.unit}}</b-input-group-text>
                                                        </template>
                                                        <input v-model="item.quantity" type="number" class="form-control iquantity" @change="totalingAmount" >
                                                    </b-input-group>
                                                    <b> Price :</b> {{item.price}}
                                                    <br /><b> Code :</b> {{item.code}}
                                                    <br /><b> Barcode :</b> {{item.barcode}}
                                                    <br /><b> Category :</b> {{item.categoryProduct}}
                                                    <br /><b> Weight :</b> {{item.weight}}
                                                    <br /><b> Length :</b> {{item.length}}
                                                    <br /><b> Height :</b> {{item.height}}
                                                    <br /><b> Width :</b> {{item.width}}
                                                    <br /><b> Volume :</b> {{item.volume}}
                                                    <br /><b> Description :</b> {{item.description}}
                                                </small></p>
                                            </div>
                                        </div>
                                    </b-card-text>
                                </b-card-body>
                            </b-collapse>
                        </b-card>
                    </div>
                </div>
                <div class="col-md-6">                                    
                    <div class="form-group">
                        <label>Weight (gr) *</label>
                        <input v-model="state.weight" type="number" class="form-control" placeholder="Enter Weight" :disabled = "viewStatus" required>
                        <div class="help-block with-errors"  v-if="v$.weight.$error" >
                            <div class="alert alert-danger">
                                <div class="iq-alert-text">
                                    {{v$.weight.$errors[0].$message}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">                                    
                    <div class="form-group">
                        <label>Amount</label>
                        <input v-model="state.amount" type="number" class="form-control" :disabled = "true" >
                        <div class="help-block with-errors"  v-if="v$.amount.$error" >
                            <div class="alert alert-danger">
                                <div class="iq-alert-text">
                                    {{v$.amount.$errors[0].$message}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-12">
                    <label>Payment Type *</label>
                    <select v-model="state.paymentType" name="type" class="form-control" :disabled = viewStatus >
                        <option value="CASH" >Cash</option>
                        <option value="TRANSFER">Transfer</option>
                        <option value="HOLD">Hold</option>
                    </select>
                    <div class="help-block with-errors"  v-if="v$.paymentType.$error" >
                        <div class="alert alert-danger">
                            <div class="iq-alert-text">
                                {{v$.paymentType.$errors[0].$message}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-12" v-if="!viewStatus">
                <button v-if="!error" type="submit" class="btn btn-primary btn-block">Continue</button>
            </div>
        </div>
    </b-form>
</template>
<style>
    .b-input-group-text-custome{
        margin-left: -10px;
        text-transform: uppercase;
        border-radius: 0px 10px 10px 0px !important;
    }
    .input-group > .input-group-text {
        border-radius: 10px 0px 0px 10px;
    }
</style>
<style scoped>
    .col-md-12:nth-child(2) > .form-group:first-child{
        margin-top: 1rem;
    }
    .row{
        padding: 1rem;
    }
    .card-title-accordion{
        padding: 10px;
        cursor: pointer;
    }
    .hide{
        display: none;
    }
    .iquantity{
        max-width: 80px;
    }
</style>
